import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Button1Listener implements ActionListener { // (1)  ̺Ʈ Ŭ
	public void actionPerformed(ActionEvent e) {
		JButton button = (JButton) e.getSource();
		button.setText("ư 1 ϴ");
	}
}

class MyFrame extends JFrame implements ActionListener { // (3) ̽ 
	JButton b1;
	JButton b2;
	JButton b3; 
	JButton b4; 
	JButton b5; 

	private class Button2Listener implements ActionListener { // (2)  ̺Ʈ Ŭ
		public void actionPerformed(ActionEvent e) {
			JButton button = (JButton) e.getSource();
			if (button == b2) {
				b1.setText("ư2  ϴ");
				b2.setText("ư2  ϴ");
				b3.setText("ư2  ϴ");
			}
		}
	}

	public MyFrame() {
		setTitle("Absolute Position Test");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(300, 300);

		JPanel p = new JPanel();
		p.setLayout(null); // ġũ 
		b1 = new JButton("Button #1");
		p.add(b1);
		b2 = new JButton("Button #2");          
		p.add(b2);
		b3 = new JButton("Button #3");          
		p.add(b3);
		b4 = new JButton("Button #4");          
		p.add(b4);
		b5 = new JButton("Button #5");          
		p.add(b5);
		b1.setBounds(20, 5, 95, 30); // ġũ 
		b2.setBounds(55, 45, 105, 70); // ġũ 
		b3.setBounds(180, 15, 105, 90); // ġũ 
		b4.setBounds(80, 120, 105, 40); // ġũ 
		b5.setBounds(20, 170, 200, 30); // ġũ 
		add(p);
		
		b1.addActionListener(new Button1Listener()); // (1)  ̺Ʈ Ŭ 
		b2.addActionListener(new Button2Listener()); // (2)  ̺Ʈ Ŭ 
		b3.addActionListener(this); // (3) ̽ 
		b4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { // (4)  ̺Ʈ Ŭ 
				JButton button = (JButton) e.getSource();
				if (button == b4) {
					b1.setText("ư4  ϴ");
					b2.setText("ư4  ϴ");
					b3.setText("ư4  ϴ");
					b4.setText("ư4  ϴ");
				}
			}
		});
		b5.addActionListener(e -> { // (5) lambda 
			b1.setText("ư5  ϴ");
			b2.setText("ư5  ϴ");
			b3.setText("ư5  ϴ");
			b4.setText("ư5  ϴ");
			b5.setText("ư5  ϴ");
		});
		
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e) { // (3) ̽ 
		JButton button = (JButton) e.getSource();
		if (button == b3) {
			b1.setText("ư3  ϴ");
			b2.setText("ư3  ϴ");
			b3.setText("ư3  ϴ");
		}
	}
}

public class AbsolutePositionTest {
	public static void main(String args[]) {
		MyFrame f = new MyFrame();
	}
}
